<!--
 Copyright (C) 2016-2020 Linagora

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU Affero General Public License as
 published by the Free Software Foundation, either version 3 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Affero General Public License for more details.

 You should have received a copy of the GNU Affero General Public License
 along with this program.  If not, see http://www.gnu.org/licenses/.
-->
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
  <modelVersion>4.0.0</modelVersion>
  <groupId>org.ow2.petals</groupId>
  <artifactId>petals-cockpit-parent</artifactId>
  <version>1.7.0-SNAPSHOT</version>
  <packaging>pom</packaging>

  <properties>
    <java-version>1.8</java-version>
    <maven.compiler.source>${java-version}</maven.compiler.source>
    <maven.compiler.target>${java-version}</maven.compiler.target>
    <maven.compiler.showWarnings>true</maven.compiler.showWarnings>
    <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>

    <liquibase.version>3.6.1</liquibase.version>
    <pac4j.version>3.6.1</pac4j.version>
    <h2.version>1.4.196</h2.version>
    <slf4j.version>1.7.26</slf4j.version>
    <jooq.version>3.9.6</jooq.version>
    <petals-admin.version>2.1.0-SNAPSHOT</petals-admin.version>
    <petals-admin-mock.version>2.1.0-SNAPSHOT</petals-admin-mock.version>
    <petals-jmx-api.version>1.2.0-SNAPSHOT</petals-jmx-api.version>
    <enunciate.version>2.10.1</enunciate.version>
  </properties>

  <modules>
    <module>backend</module>
    <module>cockpit</module>
  </modules>

  <dependencyManagement>
    <dependencies>
      <dependency>
        <groupId>org.eclipse.jetty</groupId>
        <artifactId>jetty-bom</artifactId>
        <version>9.4.11.v20180605</version>
        <type>pom</type>
        <scope>import</scope>
      </dependency>
      <dependency>
        <groupId>org.glassfish.jersey</groupId>
        <artifactId>jersey-bom</artifactId>
        <!-- since 2.26, there was a lot of breaking change,
             see https://github.com/dropwizard/dropwizard/issues/2148 -->
        <version>2.25.1</version>
        <type>pom</type>
        <scope>import</scope>
      </dependency>
      <dependency>
        <groupId>io.dropwizard</groupId>
        <artifactId>dropwizard-bom</artifactId>
        <version>1.3.8</version>
        <type>pom</type>
        <scope>import</scope>
      </dependency>
      <dependency>
        <groupId>org.pac4j</groupId>
        <artifactId>pac4j-core</artifactId>
        <version>${pac4j.version}</version>
      </dependency>
      <dependency>
        <groupId>com.google.guava</groupId>
        <artifactId>guava</artifactId>
        <version>24.1.1-jre</version>
      </dependency>
      <dependency>
        <groupId>io.javaslang</groupId>
        <artifactId>javaslang</artifactId>
        <version>2.0.6</version>
      </dependency>
      <dependency>
        <groupId>org.liquibase</groupId>
        <artifactId>liquibase-core</artifactId>
        <version>${liquibase.version}</version>
      </dependency>
      <dependency>
        <groupId>org.jooq</groupId>
        <artifactId>jooq</artifactId>
        <version>${jooq.version}</version>
      </dependency>
      <dependency>
        <groupId>org.ow2.petals</groupId>
        <artifactId>petals-admin-api</artifactId>
        <version>${petals-admin.version}</version>
      </dependency>
      <dependency>
        <groupId>org.ow2.petals</groupId>
        <artifactId>petals-admin-jmx</artifactId>
        <version>${petals-admin.version}</version>
      </dependency>
      <dependency>
        <groupId>org.ow2.petals</groupId>
        <artifactId>petals-admin-mock</artifactId>
        <version>${petals-admin-mock.version}</version>
      </dependency>
      <dependency>
        <groupId>org.ow2.petals</groupId>
        <artifactId>petals-jmx-api-api</artifactId>
        <version>${petals-jmx-api.version}</version>
      </dependency>
      <dependency>
        <groupId>org.ow2.petals</groupId>
        <artifactId>petals-jmx-api-impl</artifactId>
        <version>${petals-jmx-api.version}</version>
      </dependency>
      <dependency>
        <groupId>org.ow2.petals</groupId>
        <artifactId>petals-jmx-api-mock</artifactId>
        <version>${petals-jmx-api.version}</version>
      </dependency>
      <dependency>
        <groupId>org.eclipse.jdt</groupId>
        <artifactId>org.eclipse.jdt.annotation</artifactId>
        <version>2.1.0</version>
        <!-- Prevent the dependency from being included in distributions -->
        <scope>provided</scope>
      </dependency>
      <dependency>
        <groupId>com.h2database</groupId>
        <artifactId>h2</artifactId>
        <version>${h2.version}</version>
      </dependency>
      <dependency>
        <groupId>org.zapodot</groupId>
        <artifactId>embedded-db-junit</artifactId>
        <version>1.0-RC1</version>
      </dependency>
      <dependency>
        <groupId>org.zapodot</groupId>
        <artifactId>embedded-db-junit-liquibase</artifactId>
        <version>1.0-RC1</version>
      </dependency>
      <dependency>
        <groupId>org.assertj</groupId>
        <artifactId>assertj-core</artifactId>
        <version>3.9.1</version>
      </dependency>
      <dependency>
        <groupId>org.assertj</groupId>
        <artifactId>assertj-db</artifactId>
        <version>1.2.0</version>
      </dependency>
      <dependency>
        <groupId>com.webcohesion.enunciate</groupId>
        <artifactId>enunciate-core-annotations</artifactId>
        <version>${enunciate.version}</version>
        <!-- Prevent the dependency from being included in distributions -->
        <scope>provided</scope>
      </dependency>
      <dependency>
        <groupId>net.bytebuddy</groupId>
        <artifactId>byte-buddy</artifactId>
        <!-- because of mockito-core and embedded-db-junit -->
        <version>1.7.9</version>
      </dependency>
      <dependency>
        <groupId>net.bytebuddy</groupId>
        <artifactId>byte-buddy-agent</artifactId>
        <!-- because of mockito-core and embedded-db-junit -->
        <version>1.7.9</version>
      </dependency>
      <dependency>
        <groupId>org.slf4j</groupId>
        <artifactId>slf4j-api</artifactId>
        <version>${slf4j.version}</version>
      </dependency>
      <dependency>
        <groupId>org.slf4j</groupId>
        <artifactId>jcl-over-slf4j</artifactId>
        <version>${slf4j.version}</version>
      </dependency>
      <dependency>
        <groupId>org.slf4j</groupId>
        <artifactId>jul-to-slf4j</artifactId>
        <version>${slf4j.version}</version>
      </dependency>
      <dependency>
        <groupId>org.slf4j</groupId>
        <artifactId>log4j-over-slf4j</artifactId>
        <version>${slf4j.version}</version>
      </dependency>
    </dependencies>
  </dependencyManagement>

  <build>
    <plugins>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-enforcer-plugin</artifactId>
        <version>1.4.1</version>
        <executions>
          <execution>
            <id>enforce</id>
            <configuration>
              <rules>
                <dependencyConvergence />
                <banCircularDependencies />
                <requireUpperBoundDeps />
                <requireJavaVersion>
                  <version>[${java-version},)</version>
                </requireJavaVersion>
              </rules>
            </configuration>
            <goals>
              <goal>enforce</goal>
            </goals>
          </execution>
        </executions>
      </plugin>
      <plugin>
        <groupId>org.basepom.maven</groupId>
        <artifactId>duplicate-finder-maven-plugin</artifactId>
        <version>1.3.0</version>
        <executions>
          <execution>
            <id>enforce-no-duplicate-classes</id>
            <goals>
              <goal>check</goal>
            </goals>
            <configuration>
              <failBuildInCaseOfDifferentContentConflict>true</failBuildInCaseOfDifferentContentConflict>
              <printEqualFiles>true</printEqualFiles>
              <ignoredResourcePatterns>
                <ignoredResourcePattern>^about\.html$</ignoredResourcePattern>
                <ignoredResourcePattern>^versioneye\.properties$</ignoredResourcePattern>
              </ignoredResourcePatterns>
            </configuration>
          </execution>
        </executions>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-checkstyle-plugin</artifactId>
        <version>2.17</version>
        <executions>
          <execution>
            <id>check-header</id>
            <!-- let's do it at validate to prevent generated sources to be covered -->
            <phase>validate</phase>
            <goals>
              <goal>check</goal>
            </goals>
            <configuration>
              <configLocation>petals-checkstyle-rules.xml</configLocation>
              <headerLocation>petals-copyright-agpl3-regexp-file.txt</headerLocation>

              <consoleOutput>true</consoleOutput>
              <logViolationsToConsole>true</logViolationsToConsole>

              <includeResources>true</includeResources>
              <includeTestSourceDirectory>true</includeTestSourceDirectory>
              <includeTestResources>true</includeTestResources>
              <includes>**/*</includes>
              <resourceIncludes>**/*</resourceIncludes>
              <!--
                  We exclude following resources:
                   - JAR, class, ZIP, other binary files and log files used for unit tests
                   - Licence and note files
                   - Man pages sources
                   - Keystores, certificate, keys
                   - Images
               -->
              <resourceExcludes>**/*.jar,**/*.class,**/*.zip,**/*.bin,**/LICENSE.txt,**/NOTE,**/*.log,**/*_provideFlowStepBegin.xml,**/*_provideFlowStepEnd.xml,**/*_provideFlowStepFailure.xml,**/man1/*.1,**/man5/*.5,**/man7/*.7,**/*.jks,**/id_rsa*,**/known_hosts,**/*.jpg,**/*.png,**/*.crt,**/*.pem,META-INF/**,**/*.json,**/*.yml,**/*.yaml</resourceExcludes>
            </configuration>
          </execution>
          <execution>
            <id>check-other-source-files</id>
            <phase>validate</phase>
            <goals>
              <goal>check</goal>
            </goals>
            <configuration>
              <configLocation>petals-checkstyle-rules.xml</configLocation>
              <headerLocation>petals-copyright-agpl3-regexp-file.txt</headerLocation>

              <consoleOutput>true</consoleOutput>
              <logViolationsToConsole>true</logViolationsToConsole>

              <sourceDirectory>${basedir}</sourceDirectory>
              <includes>/pom.xml</includes>
              <includeResources>false</includeResources>
              <includeTestSourceDirectory>false</includeTestSourceDirectory>
              <includeTestResources>false</includeTestResources>
            </configuration>
          </execution>
        </executions>
        <dependencies>
          <dependency>
            <groupId>org.ow2.petals</groupId>
            <artifactId>petals-checkstyle-rules</artifactId>
            <version>1.0.8-SNAPSHOT</version>
          </dependency>
          <dependency>
            <!-- Latest version -->
            <groupId>com.puppycrawl.tools</groupId>
            <artifactId>checkstyle</artifactId>
            <version>7.5.1</version>
          </dependency>
        </dependencies>
      </plugin>
    </plugins>
    <pluginManagement>
      <plugins>
        <plugin>
          <groupId>org.jacoco</groupId>
          <artifactId>jacoco-maven-plugin</artifactId>
          <version>0.7.9</version>
          <executions>
            <execution>
            <!-- This activates the use of jacoco for recording unit and integration test coverage -->
              <id>jacoco-prepare-agent</id>
              <goals>
                <goal>prepare-agent</goal>
                <goal>prepare-agent-integration</goal>
              </goals>
            </execution>
            <execution>
            <!-- This will generate XML and HTML reports -->
              <id>jacoco-report</id>
              <goals>
                <goal>report</goal>
                <goal>report-integration</goal>
              </goals>
            </execution>
          </executions>
        </plugin>
        <plugin>
          <groupId>org.codehaus.mojo</groupId>
          <artifactId>exec-maven-plugin</artifactId>
          <version>1.5.0</version>
        </plugin>
        <!--This plugin's configuration is used to store Eclipse m2e settings only. It has no influence on the Maven build itself.-->
        <plugin>
          <groupId>org.eclipse.m2e</groupId>
          <artifactId>lifecycle-mapping</artifactId>
          <version>1.0.0</version>
          <configuration>
            <lifecycleMappingMetadata>
              <pluginExecutions>
                <pluginExecution>
                  <pluginExecutionFilter>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-dependency-plugin</artifactId>
                    <versionRange>[2.10,)</versionRange>
                    <goals>
                      <goal>properties</goal>
                    </goals>
                  </pluginExecutionFilter>
                  <action>
                    <ignore></ignore>
                  </action>
                </pluginExecution>
                <pluginExecution>
                  <pluginExecutionFilter>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-toolchains-plugin</artifactId>
                    <versionRange>[1.1,)</versionRange>
                    <goals>
                      <goal>toolchain</goal>
                    </goals>
                  </pluginExecutionFilter>
                  <action>
                    <ignore></ignore>
                  </action>
                </pluginExecution>
                <pluginExecution>
                  <pluginExecutionFilter>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-checkstyle-plugin</artifactId>
                    <versionRange>[2.17,)</versionRange>
                    <goals>
                      <goal>check</goal>
                    </goals>
                  </pluginExecutionFilter>
                  <action>
                    <ignore></ignore>
                  </action>
                </pluginExecution>
              </pluginExecutions>
            </lifecycleMappingMetadata>
          </configuration>
        </plugin>
      </plugins>
    </pluginManagement>
  </build>
</project>
